Index: NEMO/trunk/doc/latex/NEMO/subfiles/chap_misc.tex
===================================================================
--- NEMO/trunk/doc/latex/NEMO/subfiles/chap_misc.tex	(revision 14257)
+++ NEMO/trunk/doc/latex/NEMO/subfiles/chap_misc.tex	(revision 14303)
@@ -14,4 +14,5 @@
     Release & Author(s) & Modifications \\
     \hline
+    {\em   X.X} & {\em Pierre Mathiot} & {update of the closed sea section}
     {\em   4.0} & {\em ...} & {\em ...} \\
     {\em   3.6} & {\em ...} & {\em ...} \\
@@ -107,21 +108,13 @@
 \end{figure}
 
-\begin{figure}[!tbp]
-  \centering
-  \includegraphics[width=0.66\textwidth]{MISC_closea_mask_example}
-  \caption[Mask fields for the \protect\mdl{closea} module]{
-    Example of mask fields for the \protect\mdl{closea} module.
-    \textit{Left}: a closea\_mask field;
-    \textit{Right}: a closea\_mask\_rnf field.
-    In this example, if \protect\np{ln_closea}{ln\_closea} is set to \forcode{.true.},
-    the mean freshwater flux over each of the American Great Lakes will be set to zero,
-    and the total residual for all the lakes, if negative, will be put into
-    the St Laurence Seaway in the area shown.}
-  \label{fig:MISC_closea_mask_example}
-\end{figure}
-
 %% =================================================================================================
 \section[Closed seas (\textit{closea.F90})]{Closed seas (\protect\mdl{closea})}
 \label{sec:MISC_closea}
+
+\begin{listing}
+  \nlst{namclo}
+  \caption{\forcode{&namclo}}
+  \label{lst:namclo}
+\end{listing}
 
 Some configurations include inland seas and lakes as ocean
@@ -136,53 +129,50 @@
 to zero and put the residual flux into the ocean.
 
-Prior to \NEMO\ 4 the locations of inland seas and lakes was set via
-hardcoded indices for various ORCA configurations. From \NEMO\ 4 onwards
-the inland seas and lakes are defined using mask fields in the
-domain configuration file. The options are as follows.
-
-\begin{enumerate}
-\item {{\bfseries No ``closea\_mask'' field is included in domain configuration
-  file.} In this case the closea module does nothing.}
-
-\item {{\bfseries A field called closea\_mask is included in the domain
-configuration file and ln\_closea=.false. in namelist namcfg.} In this
-case the inland seas defined by the closea\_mask field are filled in
-(turned to land points) at run time. That is every point in
-closea\_mask that is nonzero is set to be a land point.}
-
-\item {{\bfseries A field called closea\_mask is included in the domain
-configuration file and ln\_closea=.true. in namelist namcfg.} Each
-inland sea or group of inland seas is set to a positive integer value
-in the closea\_mask field (see \autoref{fig:MISC_closea_mask_example}
-for an example). The net surface flux over each inland sea or group of
+The inland seas and lakes are defined using mask fields in the
+domain configuration file. Special treatment of the closed sea (redistribution of net freshwater or mask those), are defined in \autoref{lst:namclo} and
+can be trigger by \np{ln_closea}{ln\_closea}\forcode{=.true.} in namelist namcfg.
+
+The options available are the following:
+\begin{description}
+\item[\np{ln_maskcs}{ln\_maskcs}\forcode{ = .true.}] All the closed seas are masked using \textit{mask\_opensea} variable.
+\item[\np{ln_maskcs}{ln\_maskcs}\forcode{ = .false.}] The net surface flux over each inland sea or group of
 inland seas is set to zero each timestep and the residual flux is
-distributed over the global ocean (ie. all ocean points where
-closea\_mask is zero).}
-
-\item {{\bfseries Fields called closea\_mask and closea\_mask\_rnf are
-included in the domain configuration file and ln\_closea=.true. in
-namelist namcfg.} This option works as for option 3, except that if
-the net surface flux over an inland sea is negative (net
-precipitation) it is put into the ocean at specified runoff points. A
-net positive surface flux (net evaporation) is still spread over the
-global ocean. The mapping from inland seas to runoff points is defined
-by the closea\_mask\_rnf field. Each mapping is defined by a positive
-integer value for the inland sea(s) and the corresponding runoff
-points. An example is given in
-\autoref{fig:MISC_closea_mask_example}. If no mapping is provided for a
-particular inland sea then the residual is spread over the global
-ocean.}
-
-\item {{\bfseries Fields called closea\_mask and closea\_mask\_emp are
-included in the domain configuration file and ln\_closea=.true. in
-namelist namcfg.} This option works the same as option 4 except that
-the nonzero net surface flux is sent to the ocean at the specified
-runoff points regardless of whether it is positive or negative. The
-mapping from inland seas to runoff points in this case is defined by
-the closea\_mask\_emp field.}
-\end{enumerate}
-
-There is a python routine to create the closea\_mask fields and append
-them to the domain configuration file in the utils/tools/DOMAINcfg directory.
+distributed over a target area.
+\end{description}
+
+When \np{ln_maskcs}{ln\_maskcs}\forcode{ = .false.}, 
+3 options are available for the redistribution (set up of these options is done in the tool DOMAINcfg):
+\begin{description}[font=$\bullet$ ]
+\item[ glo]: The residual flux is redistributed globally.
+\item[ emp]: The residual flux is redistributed as emp in a river outflow.
+\item[ rnf]: The residual flux is redistributed as rnf in a river outflow if negative. If there is a net evaporation, the residual flux is redistributed globally.
+\end{description}
+
+For each case, 2 masks are needed (\autoref{fig:MISC_closea_mask_example}): 
+\begin{description}
+\item $\bullet$ one describing the 'sources' (ie the closed seas concerned by each options) called \textit{mask\_csglo}, \textit{mask\_csrnf}, \textit{mask\_csemp}. 
+\item $\bullet$ one describing each group of inland seas (the Great Lakes for example) and the target area (river outflow or world ocean) for each group of inland seas (St Laurence for the Great Lakes for example) called
+\textit{mask\_csgrpglo}, \textit{mask\_csgrprnf}, \textit{mask\_csgrpemp}.
+\end{description}
+
+\begin{figure}[!tbp]
+  \centering
+  \includegraphics[width=0.66\textwidth]{MISC_closea_mask_example}
+  \caption[Mask fields for the \protect\mdl{closea} module]{
+    Example of mask fields for the \protect\mdl{closea} module.
+    \textit{Left}: a \textit{mask\_csrnf} field;
+    \textit{Right}: a \textit{mask\_csgrprnf} field.
+    In this example, if \protect\np{ln_closea}{ln\_closea} is set to \forcode{.true.},
+    the mean freshwater flux over each of the American Great Lakes will be set to zero,
+    and the total residual for all the lakes, if negative, will be put into
+    the St Laurence Seaway in the area shown.}
+  \label{fig:MISC_closea_mask_example}
+\end{figure}
+
+Closed sea not defined (because too small, issue in the bathymetry definition ...) are defined in \textit{mask\_csundef}.
+These points can be masked using the namelist option \np{ln_mask_csundef}{ln\_mask\_csundef}\forcode{= .true.} or used to correct the bathymetry input file.\\
+
+The masks needed for the closed sea can be created using the DOMAINcfg tool in the utils/tools/DOMAINcfg directory.
+See \autoref{sec:clocfg} for details on the usage of definition of the closed sea masks.
 
 %% =================================================================================================