Index: NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/cfgs/SHARED/namelist_sediment_ref
===================================================================
--- NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/cfgs/SHARED/namelist_sediment_ref	(revision 14276)
+++ NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/cfgs/SHARED/namelist_sediment_ref	(revision 14306)
@@ -101,12 +101,12 @@
    rcorgr   =  1.E-4   ! Reactivity for refractory POC [an-1]
    rcnh4    =  1E7     ! Reactivity for O2/NH4 [l.mol-1.an-1]
-   rch2s    =  1.6E5   ! Reactivity for O2/H2S [l.mol-1.an-1]
+   rch2s    =  2E8     ! Reactivity for O2/H2S [l.mol-1.an-1]
    rcfe2    =  1E8     ! Reactivity for O2/Fe2+ [l.mol-1.an-1]
-   rcfeh2s  =  8E3     ! Reactivity for FEOH/H2S [l.mol-1.an-1]
+   rcfeh2s  =  1E4     ! Reactivity for FEOH/H2S [l.mol-1.an-1]
    rcfes    =  1E6     ! Reactivity for FE2+/H2S [l.mol-1.an-1]
-   rcfeso   =  3E5     ! Reactivity for FES/O2 [l.mol-1.an-1]
+   rcfeso   =  2E7     ! Reactivity for FES/O2 [l.mol-1.an-1]
    xksedo2  =  1.E-6   ! Half-saturation constant for oxic remin [mol/l]
    xksedno3 =  10.E-6  ! Half-saturation constant for denitrification [mol/l] 
-   xksedfeo =  0.6     ! Half-saturation constant for iron remin [%]
+   xksedfeo =  0.007   ! Half-saturation constant for iron remin [%]
    xksedso4 =  2E-3    ! Half-saturation constant for SO4 remin [mol/l]
 /
@@ -130,2 +130,11 @@
    cn_sedrst_outdir = "."          !  directory to which to write output sediment restarts
 /
+!-----------------------------------------------------------------------
+&nam_output     !   parameters for outputing the sediment module
+!-----------------------------------------------------------------------
+   ldefsedpis_avg = .true.            !  write averaged output variables
+   cn_sedwri_out  = "output_sed.nc"   !  name of the input restart file name of the sediment module
+   nrpfsedpis_avg = 0                 ! Frequency of the averaged outputs
+   nwrtsedpis_avg = 24                ! Frequency of the averaged outputs
+   ntssedpis_avg  =  1                ! ???
+/
Index: NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/SED/seddta.F90
===================================================================
--- NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/SED/seddta.F90	(revision 14276)
+++ NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/SED/seddta.F90	(revision 14306)
@@ -158,5 +158,5 @@
 !        zf1    = MIN(0.98, MAX(0., zf1 ) )
          zf1    = 0.7
-         zf2    = 0.04
+         zf2    = 0.02
          zf0    = 1.0 - zf2 - zf1
          rainrm_dta(ji,jspoc) =   ( zdtap(ji) +  zdtag(ji) ) * 1e-4 * zf0
@@ -164,4 +164,5 @@
          rainrm_dta(ji,jspor) =   ( zdtap(ji) +  zdtag(ji) ) * 1e-4 * zf2
       END DO
+
       !  Sinking fluxes for Calcite in mol.m-2.s-1 ; conversion in mol.cm-2.s-1
       CALL pack_arr ( jpoce,  rainrm_dta(1:jpoce,jscal), trc_data(1:jpi,1:jpj,14), iarroce(1:jpoce) )
@@ -177,6 +178,7 @@
       rainrm_dta(1:jpoce,jsclay) = rainrm_dta(1:jpoce,jsclay) * conv2 / mol_wgt(jsclay)   &
       &                            + wacc(1:jpoce) * por1(2) * denssol / mol_wgt(jsclay) / ( rsecday * 365.0 )
-      rainrm_dta(1:jpoce,jsfeo)  = rainrm_dta(1:jpoce,jsclay) * mol_wgt(jsclay) / mol_wgt(jsfeo) * 0.035 * 0.5
-      rainrm_dta(1:jpoce,jsclay) = rainrm_dta(1:jpoce,jsclay) * 0.965
+      rainrm_dta(1:jpoce,jsfeo)  = rainrm_dta(1:jpoce,jsclay) * mol_wgt(jsclay) / mol_wgt(jsfeo) * 0.035 * 0.5 * 0.333
+      rainrm_dta(1:jpoce,jsclay) = rainrm_dta(1:jpoce,jsclay) * (1.0 - 0.035 * 0.5 * 0.333 )
+
 !    rainrm_dta(1:jpoce,jsclay) = 1.0E-4 * conv2 / mol_wgt(jsclay)
 
Index: NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/SED/sedini.F90
===================================================================
--- NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/SED/sedini.F90	(revision 14276)
+++ NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/SED/sedini.F90	(revision 14306)
@@ -40,5 +40,5 @@
 
    REAL(wp), PUBLIC    ::  &
-      redO2    =  172.  ,  &  !: Redfield coef for Oxygen
+      redO2    =  133.  ,  &  !: Redfield coef for Oxygen
       redNo3   =   16.  ,  &  !: Redfield coef for Nitrate
       redPo4   =    1.  ,  &  !: Redfield coef for Phosphate
@@ -70,8 +70,8 @@
 
    REAL(wp), DIMENSION(jpwat), PUBLIC  :: diff1
-   DATA diff1/4.59E-6, 1.104E-5, 4.81E-6 , 9.78E-6, 3.58E-6, 4.01E-6, 9.8E-6, 9.73E-6, 5.0E-6, 3.31E-6 /
+   DATA diff1/4.59E-6, 1.104E-5, 4.81E-6 , 9.78E-6, 3.58E-6, 4.81E-6, 9.8E-6, 9.73E-6, 5.0E-6, 3.31E-6 /
 
    REAL(wp), DIMENSION(jpwat), PUBLIC  :: diff2
-   DATA diff2/1.74E-7, 4.47E-7, 2.51E-7, 3.89E-7, 1.77E-7, 2.5E-7, 3.89E-7, 3.06E-7, 2.5E-7, 1.5E-7 /
+   DATA diff2/1.74E-7, 4.47E-7, 2.51E-7, 3.89E-7, 1.77E-7, 2.51E-7, 3.89E-7, 3.06E-7, 2.5E-7, 1.5E-7 /
 
 
@@ -217,5 +217,4 @@
       ! --------------------------------
       IF (ln_sediment_offline) THEN
-         CALL trc_dta_ini(jptra)
          CALL trc_dmp_sed_ini
       ENDIF
Index: NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/SED/sedwri.F90
===================================================================
--- NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/SED/sedwri.F90	(revision 14276)
+++ NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/SED/sedwri.F90	(revision 14306)
@@ -103,5 +103,5 @@
       ! Calculation of fluxes g/cm2/s
       DO js = 1, jpsol
-         zrate =  1.0 / ( por1(jpksed) ) / r2dttrc
+         zrate =  1.0 / r2dttrc
          DO ji = 1, jpoce
             zflx(ji,jpwat+js) = zflx(ji,jpwat+js) + ( tosed(ji,js) - fromsed(ji,js) ) * zrate
@@ -111,5 +111,5 @@
       ! Calculation of accumulation rate per dt
       DO js = 1, jpsol
-         zrate =  1.0 / ( por1(jpksed) ) / r2dttrc
+         zrate =  1.0 / r2dttrc
          DO ji = 1, jpoce
             zflx(ji,jptrased+1) = zflx(ji,jptrased+1) + ( tosed(ji,js) - fromsed(ji,js) ) * zrate
Index: NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/trcini.F90
===================================================================
--- NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/trcini.F90	(revision 14276)
+++ NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/trcini.F90	(revision 14306)
@@ -252,4 +252,5 @@
                   !
                   ! deallocate data structure if data are not used for damping
+#if ! defined key_sed_off
                   IF( .NOT.ln_trcdmp .AND. .NOT.ln_trcdmp_clo ) THEN
                      IF(lwp) WRITE(numout,*) 'trc_ini_state: deallocate data arrays as they are only used to initialize the run'
@@ -258,4 +259,5 @@
                      !
                   ENDIF
+#endif
                ENDIF
             END DO
Index: NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/trcnam.F90
===================================================================
--- NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/trcnam.F90	(revision 14276)
+++ NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/trcnam.F90	(revision 14306)
@@ -62,4 +62,7 @@
       !
       IF( ln_trcdmp .OR. ln_trcdmp_clo )   ln_trcdta = .TRUE.    ! damping : need to have clim data
+#if defined key_sed_off
+      ln_trcdta = .TRUE.
+#endif
       !
       !