Index: NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/cfgs/ORCA2_OFF_TRC/EXPREF/context_nemo.xml
===================================================================
--- NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/cfgs/ORCA2_OFF_TRC/EXPREF/context_nemo.xml	(revision 14238)
+++ NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/cfgs/ORCA2_OFF_TRC/EXPREF/context_nemo.xml	(revision 14328)
@@ -20,9 +20,10 @@
 
 <!-- Fields definition -->
-    <field_definition src="./field_def_nemo-oce.xml"/>    <!--  NEMO ocean dynamics     -->
-    <field_definition src="./field_def_nemo-innerttrc.xml"/> <!--  NEMO ocean biology      -->
+    <field_definition src="./field_def_nemo-oce.xml"/>      <!--  NEMO ocean dynamics     -->
+    <field_definition src="./field_def_nemo-pisces.xml"/>    <!--  NEMO ocean biogeochemistry     -->
+    <field_definition src="./field_def_nemo-innerttrc.xml"/> <!--  NEMO ocean passive tracers      -->
 
 <!-- Files definition -->
-    <file_definition src="./file_def_nemo-innerttrc.xml"/>  <!--  NEMO ocean biology       -->
+    <file_definition src="./file_def_nemo-innerttrc.xml"/>  <!--  NEMO ocean passive tracers       -->
 
 
Index: NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/cfgs/ORCA2_OFF_TRC/EXPREF/field_def_nemo-pisces.xml
===================================================================
--- NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/cfgs/ORCA2_OFF_TRC/EXPREF/field_def_nemo-pisces.xml	(revision 14328)
+++ NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/cfgs/ORCA2_OFF_TRC/EXPREF/field_def_nemo-pisces.xml	(revision 14328)
@@ -0,0 +1,1 @@
+link ../../SHARED/field_def_nemo-pisces.xml
Index: NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/cfgs/ORCA2_OFF_TRC/EXPREF/file_def_nemo-innerttrc.xml
===================================================================
--- NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/cfgs/ORCA2_OFF_TRC/EXPREF/file_def_nemo-innerttrc.xml	(revision 14238)
+++ NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/cfgs/ORCA2_OFF_TRC/EXPREF/file_def_nemo-innerttrc.xml	(revision 14328)
@@ -31,11 +31,16 @@
 
       <file_group id="1y"  output_freq="1y" output_level="10" enabled=".TRUE."> <!-- real yearly files -->
+	      
+	<file id="file1" name_suffix="grid_T" description="passive tracers variables" >
+           <field field_ref="e3t"     />
+           <field field_ref="ssh"    name="zos"  />
+         </file>
 
-        <file id="file1" name_suffix="_ptrc_T" description="passive tracers variables" >
-           <field field_ref="Age"    />
-           <field field_ref="CFC11"  />
-           <field field_ref="CFC12"  />
-           <field field_ref="SF6"    />
-           <field field_ref="RC14"   />
+	 <file id="file1" name_suffix="_trc" description="passive tracers variables" >
+           <field field_ref="Age"     name="Age"     operation="average" freq_op="1y"  > @Age_e3t / @e3t   </field>		      
+           <field field_ref="CFC11"   name="CFC11"   operation="average" freq_op="1y"  > @CFC11_e3t / @e3t </field>
+           <field field_ref="CFC12"   name="CFC12"   operation="average" freq_op="1y"  > @CFC12_e3t / @e3t </field>
+           <field field_ref="SF6"     name="SF6"     operation="average" freq_op="1y"  > @SF6_e3t / @e3t   </field>
+           <field field_ref="RC14"    name="RC14"    operation="average" freq_op="1y"  > @RC14_e3t / @e3t  </field>
          </file>
 
Index: NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/cfgs/ORCA2_OFF_TRC/EXPREF/namelist_cfg
===================================================================
--- NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/cfgs/ORCA2_OFF_TRC/EXPREF/namelist_cfg	(revision 14238)
+++ NEMO/branches/2020/dev_14237_KERNEL-01_IMMERSE_SEAMOUNT/cfgs/ORCA2_OFF_TRC/EXPREF/namelist_cfg	(revision 14328)
@@ -22,7 +22,7 @@
    cn_exp      =  "TRACERS"  !  experience name
    nn_it000    =       1     !  first time step
-   nn_itend    =    14600    !  last  time step (std 5475)
+   nn_itend    =    1460    !  last  time step (std 5475)
    nn_date0    =  19600101   !  date at nit_0000 (format yyyymmdd) used if ln_rstart=F or (ln_rstart=T and nn_rstctl=0 or 1)
-   nn_stock    =    14600    !  frequency of creation of a restart file (modulo referenced to 1)
+   nn_stock    =    1460    !  frequency of creation of a restart file (modulo referenced to 1)
    ln_mskland  = .true.      !  mask land points in NetCDF outputs (costly: + ~15%)
    ln_cfmeta   = .true.      !  output additional data to netCDF files required for compliance with the CF metadata standard
@@ -32,5 +32,4 @@
 &namdom        !   time and space domain
 !-----------------------------------------------------------------------
-   ln_linssh   = .true.   !  =T  linear free surface  ==>>  model level are fixed in time
    !
    rn_Dt      = 21600.     !  time step for the dynamics and tracer
@@ -197,4 +196,5 @@
 &namdrg        !   top/bottom drag coefficient                          (default: NO selection)
 !-----------------------------------------------------------------------
+   ln_drg_OFF  = .true.   !  free-slip  
 /
 !-----------------------------------------------------------------------
@@ -308,26 +308,28 @@
 &namdta_dyn    !   offline ocean input files                            (OFF_SRC only)
 !-----------------------------------------------------------------------
-   ln_dynrnf       =  .false.    !  runoffs option enabled (T) or not (F)
+   ln_dynrnf       =  .true.    !  runoffs option enabled (T) or not (F)
    ln_dynrnf_depth =  .false.    !  runoffs is spread in vertical (T) or not (F)
-!   fwbcorr        = 3.786e-06   !  annual global mean of empmr for ssh correction
-
+   !
    cn_dir      = './'      !  root directory for the ocean data location
-   !___________!_________________________!___________________!___________!_____________!________!___________!__________________!__________!_______________!
-   !           !  file name              ! frequency (hours) ! variable  ! time interp.!  clim  ! 'yearly'/ ! weights filename ! rotation ! land/sea mask !
-   !           !                         !  (if <0  months)  !   name    !   (logical) !  (T/F) ! 'monthly' !                  ! pairing  !    filename   !
-   sn_tem      = 'dyna_grid_T'           ,       120.        , 'votemper'  ,  .true.   , .true. , 'yearly'  , ''               , ''       , ''
-   sn_sal      = 'dyna_grid_T'           ,       120.        , 'vosaline'  ,  .true.   , .true. , 'yearly'  , ''               , ''       , ''
-   sn_mld      = 'dyna_grid_T'           ,       120.        , 'somixhgt'  ,  .true.   , .true. , 'yearly'  , ''               , ''       , ''
-   sn_emp      = 'dyna_grid_T'           ,       120.        , 'sowaflup'  ,  .true.   , .true. , 'yearly'  , ''               , ''       , ''
-   sn_fmf      = 'dyna_grid_T'           ,       120.        , 'iowaflup'  ,  .true.   , .true. , 'yearly'  , ''               , ''       , ''
-   sn_ice      = 'dyna_grid_T'           ,       120.        , 'soicecov'  ,  .true.   , .true. , 'yearly'  , ''               , ''       , ''
-   sn_qsr      = 'dyna_grid_T'           ,       120.        , 'soshfldo'  ,  .true.   , .true. , 'yearly'  , ''               , ''       , ''
-   sn_wnd      = 'dyna_grid_T'           ,       120.        , 'sowindsp'  ,  .true.   , .true. , 'yearly'  , ''               , ''       , ''
-   sn_uwd      = 'dyna_grid_U'           ,       120.        , 'uocetr_eff',  .true.   , .true. , 'yearly'  , ''               , ''       , ''
-   sn_vwd      = 'dyna_grid_V'           ,       120.        , 'vocetr_eff',  .true.   , .true. , 'yearly'  , ''               , ''       , ''
-   sn_wwd      = 'dyna_grid_W'           ,       120.        , 'wocetr_eff',  .true.   , .true. , 'yearly'  , ''               , ''       , ''
-   sn_avt      = 'dyna_grid_W'           ,       120.        , 'voddmavs'  ,  .true.   , .true. , 'yearly'  , ''               , ''       , ''
-   sn_ubl      = 'dyna_grid_U'           ,       120.        , 'sobblcox'  ,  .true.   , .true. , 'yearly'  , ''               , ''       , ''
-   sn_vbl      = 'dyna_grid_V'           ,       120.        , 'sobblcoy'  ,  .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   !___________!_________________________!___________________!_____________!_____________!________!___________!__________________!__________!_______________!
+   !           !  file name              ! frequency (hours) !   variable  ! time interp.!  clim  ! 'yearly'/ ! weights filename ! rotation ! land/sea mask !
+   !           !                         !  (if <0  months)  !     name    !   (logical) !  (T/F) ! 'monthly' !                  ! pairing  !    filename   !
+   sn_tem      = 'dyna_grid_T'           ,       120.        , 'thetao'    ,    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_sal      = 'dyna_grid_T'           ,       120.        , 'so'        ,    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_div      = 'dyna_grid_T'           ,       120.        , 'hdivtr'    ,    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_mld      = 'dyna_grid_T'           ,       120.        , 'mldr10_1'  ,    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_emp      = 'dyna_grid_T'           ,       120.        , 'wfo'       ,    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_empb     = 'dyna_grid_T'           ,       120.        , 'wfob'      ,    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_fmf      = 'dyna_grid_T'           ,       120.        , 'fmmflx'    ,    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_rnf      = 'dyna_grid_T'           ,       120.        , 'runoffs'   ,    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_ice      = 'dyna_grid_T'           ,       120.        , 'siconc'    ,    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_qsr      = 'dyna_grid_T'           ,       120.        , 'rsntds'    ,    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_wnd      = 'dyna_grid_T'           ,       120.        , 'windsp'    ,    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_uwd      = 'dyna_grid_U'           ,       120.        , 'uocetr_eff',    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_vwd      = 'dyna_grid_V'           ,       120.        , 'vocetr_eff',    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_wwd      = 'dyna_grid_W'           ,       120.        , 'wocetr_eff',    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_avt      = 'dyna_grid_W'           ,       120.        , 'difvsolog' ,    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_ubl      = 'dyna_grid_U'           ,       120.        , 'ahu_bbl'   ,    .true.   , .true. , 'yearly'  , ''               , ''       , ''
+   sn_vbl      = 'dyna_grid_V'           ,       120.        , 'ahv_bbl'   ,    .true.   , .true. , 'yearly'  , ''               , ''       , ''
 /
 !!======================================================================
@@ -345,4 +347,5 @@
 &namzdf        !   vertical physics manager                             (default: NO selection)
 !-----------------------------------------------------------------------
+   ln_zdfcst   = .true.      !  constant mixing
 /
 !-----------------------------------------------------------------------